
#include <gtk/gtk.h>
#include <string.h>

#include "users.h"
#include "pmnotebook.h"

int pm_in_notebook = 1;
extern GYACHI_NOTEBOOK_INTERFACE *conversation;

/* Our usual callback function */
static void callback( GtkWidget *widget,
                      gpointer   data )
{
  GtkWidget *notebook;
  GtkWidget *entry;
  char text[50];
  int page;
  GtkWidget *pm_window;

  sprintf(text, "%s", gtk_label_get_text(GTK_LABEL(data)));
  g_print ("Hello again - %s was pressed\n", text);
  strncpy(&text[1], "tab", 3);
  pm_notebook_select_tab(conversation, &text[1]);

  page = gtk_notebook_get_current_page(GTK_NOTEBOOK(conversation->notebook));
  pm_window = gtk_notebook_get_nth_page(GTK_NOTEBOOK(conversation->notebook), page);
  entry = g_object_get_data(G_OBJECT(pm_window), "entry");
  gtk_widget_grab_focus(GTK_WIDGET(entry));
}


int main( int   argc,
          char *argv[] )
{
  static GtkWidget* window = NULL;
  GtkWidget *vbox;
  GtkWidget *frame;
  GtkWidget *bbox;
  GtkWidget *button;
  GtkWidget *label;
  GtkWidget *entry;
  GtkWidget *nb_frame;
  char text[100];
  int i;

  /* Initialize GTK */
  gtk_init (&argc, &argv);

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window), "Button Boxes");

  g_signal_connect (G_OBJECT (window), "destroy",
		    G_CALLBACK (gtk_main_quit),
		    NULL);

  gtk_container_set_border_width (GTK_CONTAINER (window), 10);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (window), vbox);

  gtk_container_set_border_width (GTK_CONTAINER (vbox), 10);

  frame = gtk_frame_new ("Spread (spacing 5)");

  bbox = gtk_vbutton_box_new ();

  gtk_container_set_border_width (GTK_CONTAINER (bbox), 5);
  gtk_container_add (GTK_CONTAINER (frame), bbox);

  /* Set the appearance of the Button Box */
  gtk_button_box_set_layout (GTK_BUTTON_BOX (bbox), GTK_BUTTONBOX_SPREAD);
  gtk_box_set_spacing (GTK_BOX (bbox), 5);

  for (i=1; i<5; i++) {
    sprintf(text, "line %d", i);
  
    /* Create a new button */
    button = gtk_button_new ();

    /* Create a label for the button */
    label = gtk_label_new (text);

    /* Connect the "clicked" signal of the button to our callback */
    g_signal_connect (G_OBJECT (button), "clicked",
		      G_CALLBACK (callback), (gpointer) label);

    gtk_widget_show (button);
    gtk_widget_show (label);

    gtk_container_add (GTK_CONTAINER (bbox), button);

    /* now for the notebook tab */
    nb_frame = gtk_frame_new ("my frame");

    entry = gtk_entry_new ();
    gtk_container_add (GTK_CONTAINER(nb_frame), entry);
    gtk_entry_set_max_length (GTK_ENTRY (entry), 50);
    sprintf(text, "hello world, line %d", i);
    gtk_entry_set_text (GTK_ENTRY (entry), text);
    gtk_widget_show (entry);
  
    sprintf(text, "tab %d", i);
    pm_notebook_add_window(nb_frame, text);
    g_object_set_data(G_OBJECT(label),    "notebook", nb_frame);
    g_object_set_data(G_OBJECT(nb_frame), "entry",    entry   );
    gtk_container_add (GTK_CONTAINER (button), label);
  }


  gtk_box_pack_start (GTK_BOX (vbox), frame, TRUE, TRUE, 0);

  gtk_widget_show_all (window);

  /* Enter the event loop */
  gtk_main ();
    
  return 0;
}
